"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withChannelData = void 0;

var _react = _interopRequireDefault(require("react"));

var R = _interopRequireWildcard(require("ramda"));

var _lodash = _interopRequireDefault(require("lodash.get"));

var _extended = require("./client/extended");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

// import { evolveTsToDate, ensureTsV3 } from './dm-utils';
// const get = require('lodash.get');
var act = function act(conf) {
  return function (pl) {
    return conf.forEach(function (ch) {
      return _extended.i4Context.client.pub(ch, pl);
    });
  };
};

function confToChannelNames(conf) {
  if (conf.channel && conf.channel.id) return [conf.channel.id];

  if (conf.channels) {
    return conf.channels.reduce(function (r, cc) {
      if (cc.id) r.push(cc.id);
      return r;
    }, []);
  }

  return [];
}
/**
 * DEPRECATED Higher Order Function for data subscriptions into props. Use withSub instead.
 * (Still needed if subscription needs to be combined with withUnits & withUnitsTransform ??)
 * @func
 * @static
 * @param {type} keyChannelMap A configuration of subscriptions in this form:
 * {
 *   <prop-name>: { init, actuator, subs: [{ rid, last, tail, ttl, path, transform }] }
 * }
 * where last is a bool, tail is a number and ttl is a number of seconds.
 * @returns {type} Description
 */


var withChannelData = function withChannelData(keyChannelMap) {
  return function (Component) {
    var WithChannelData__ = /*#__PURE__*/function (_React$Component) {
      _inherits(WithChannelData__, _React$Component);

      var _super = _createSuper(WithChannelData__);

      function WithChannelData__(props) {
        var _this;

        _classCallCheck(this, WithChannelData__);

        _this = _super.call(this, props);
        _this.actuators = {};
        _this.subscriptions = [];

        if (!keyChannelMap || _typeof(keyChannelMap) !== 'object') {
          console.warn('WithChannelData keyChannelMap:', keyChannelMap);
          return _possibleConstructorReturn(_this);
        }

        _this.state = Object.entries(keyChannelMap).reduce(function (r, _ref) {
          var _ref2 = _slicedToArray(_ref, 2),
              key = _ref2[0],
              conf = _ref2[1];

          return conf.init !== undefined ? _objectSpread({}, r, _defineProperty({}, key, conf.init)) : r;
        }, {}); // console.log('withChannelData state init:', this.state);

        return _this;
      }

      _createClass(WithChannelData__, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          var _this2 = this;

          if (!keyChannelMap || _typeof(keyChannelMap) !== 'object') return;
          Object.entries(keyChannelMap).forEach(function (_ref3) {
            var _ref4 = _slicedToArray(_ref3, 2),
                key = _ref4[0],
                conf = _ref4[1];

            // console.log('keyChannelMap key conf:', key, conf);
            if (conf.actuator) {
              _this2.actuators[key] = act(confToChannelNames(conf));
            }

            if (conf.subs) {
              conf.subs.forEach( /*#__PURE__*/function () {
                var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(channel) {
                  var transform, unsub;
                  return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          if (!(!channel || channel.rid === undefined)) {
                            _context.next = 2;
                            break;
                          }

                          return _context.abrupt("return");

                        case 2:
                          transform = channel.transform;
                          _context.next = 5;
                          return (0, _extended.fromChannel)(_objectSpread({}, channel, {
                            // rid, last, tail, ttl, path
                            cb: _this2.onMsg({
                              key: key,
                              // path,
                              transform: transform || conf.transform
                            })
                          }));

                        case 5:
                          unsub = _context.sent;
                          if (unsub) _this2.subscriptions = R.append(unsub)(_this2.subscriptions);

                        case 7:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                return function (_x) {
                  return _ref5.apply(this, arguments);
                };
              }());
            }
          });
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.subscriptions.forEach(function (unsub) {
            return unsub();
          });
        }
      }, {
        key: "onMsg",
        value: function onMsg(_ref6) {
          var _this3 = this;

          var transform = _ref6.transform,
              key = _ref6.key,
              path = _ref6.path;
          return function (msg) {
            // console.log('onMsg', path, typeof transform, transform, key);
            var data = path ? (0, _lodash["default"])(msg, path) : msg; // if (transform && msg) {
            //   console.log('onMsg:', typeof transform, transform, key);
            // }

            _this3.setState(function (state) {
              var prevProp = state[key];
              if (data === undefined) return undefined;
              var value = transform ? transform(data, prevProp) : data; // if (transform && msg) {
              //   console.log('onMsg tr:', value);
              // }

              if (value === undefined) return undefined;
              return _defineProperty({}, key, value);
            });
          };
        }
      }, {
        key: "render",
        value: function render() {
          // console.log('withChannelData render:', this.props, this.state);
          return /*#__PURE__*/_react["default"].createElement(Component, _extends({}, this.props, this.state, this.actuators));
        }
      }]);

      return WithChannelData__;
    }(_react["default"].Component);

    return WithChannelData__;
  };
};

exports.withChannelData = withChannelData;